:li

!!! Listing 1

template<class T>
class MatrixA            // 2-dimensionale Matrix
{  int xDim, yDim;
   T* start;
 public:
   MatrixA(int x,int y): xDim(x), yDim(y), start(new T[x*y]) {};
   ~MatrixA() { delete [] start;}
   T* operator[](int i) {return start+i*xDim};
};

!!! Ende Listing 1

!!! Listing 2

template<class T>
class MatrixB            // 2-dimensionale Matrix
{  int xDim, yDim;
   T** start;
public:
   MatrixB(int,int);
   ~MatrixB();
   // Rest weggelassen
};

template<class T>
MatrixB<T>::MatrixB(int x, int y)     // Konstruktor
: xDim(x), yDim(y)
{     start = new T*[xDim];
      // Zeilen anlegen
      for (int i = 0; i < xDim; i++)
         start[i] = new T[yDim];
}

template<class T>
MatrixB<T>::~MatrixB()
{   for (int i = 0; i < xDim; i++)
       delete start[i];
    delete start;
}

!!! Ende Listing 2

!!! Listing 3

// assertex.h
#ifndef assertex_h
#define assertex_h

 #ifdef NDEBUG
   #define Assert(Bedingung, Ausnahme) /* nichts tun */
 #else
   #define Assert(Bedingung, Ausnahme) \
      { if (!(Bedingung)) throw Ausnahme();}
 #endif
#endif
// Ende von assertex.h

!!! Ende Listing 3

!!! Listing 4

// vektor.t
#ifndef vektor_t
#define vektor_t
#include"assertex.h"

class VektorBereichsFehler {};  // zur Fehlerbehandlung

template<class T>
class Vektor {
protected:
    T   *start;              // Zeiger auf Datenobjekte
    int  xDim;               // Anzahl der Datenobjekte

public:
    Vektor(int x=0) : xDim(x), start(new T[x]) {}
    Vektor(const Vektor<T>& v);
    virtual ~Vektor() { delete [] start;}
    int  Groesse() const {return xDim;}
    void GroesseAendern(int);                 // dynamisch ndern

    // Indexoperator
    T&        operator[](int index)
    {    Assert(index >= 0  &&  index < xDim, VektorBereichsFehler);
         return start[index];
    }
    const T&  operator[](int index) const     // fr konstante Objekte
    {    Assert(index >= 0  &&  index < xDim, VektorBereichsFehler);
         return start[index];
    }

    Vektor<T>& operator=(const Vektor<T>&);      // Zuweisungsoperator

    void init(const T&);                 // Initialisierung des Vektors
};

!!! Ende Listing 4

!!! Listing 5

template<class T>
Vektor<T>::Vektor(const Vektor<T> &v)
{   xDim  = v.xDim;
    start = new T[xDim];
    for (int i = 0; i < xDim; i++) start[i] = v.start[i];
}

template<class T>
void Vektor<T>::GroesseAendern(int neueGroesse)
{   // neuen Speicherplatz besorgen
    T *pTemp = new T[neueGroesse];
    // die richtige Anzahl von Elementen kopieren
    int kleinereZahl = (neueGroesse > xDim) ? xDim : neueGroesse;
    for (int i = 0; i < kleinereZahl; i++)
        pTemp[i] = start[i];

    // alten Speicherplatz freigeben
    delete [] start;
    // Verwaltungsdaten aktualisieren
    start = pTemp;
    xDim  = neueGroesse;
}


template<class T>
Vektor<T> &Vektor<T>::operator=(const Vektor<T> &v)
{   if (this != &v)                    // v=v vermeiden!
    {  delete[] start;
       xDim  = v.xDim;
       start = new T[xDim];
       for (int i = 0; i < xDim; i++) start[i] = v.start[i];
    }
    return *this;
}

template<class T>
void Vektor<T>::init(const T& wert)
{    for (int i=0; i<xDim; i++) start[i]=wert;
}
#endif
// Ende von vektor.t

!!! Ende Listing 5

!!! Listing 6

// mvektor.t
#ifndef mvektor_t
#define mvektor_t
#include"vektor.t"

template<class T>
class mathVektor : public Vektor<T>
{
   public:
        mathVektor(int x=0) : Vektor<T>(x)  { }

        // Operator
        mathVektor& operator*=(T);
        // weitere Operatoren und Methoden .....
};

!!! Ende Listing 6

!!! Listing 7

template<class T>          // Multiplikationsoperator *=
mathVektor<T>& mathVektor<T>::operator*=(T number)
{   for (int i = 0; i < xDim; i++)
       start[i] = start[i]*number;
    return *this;
}

!!! Ende Listing 7

!!! Listing 8

// binrer * Operator fr den Fall vekt1 = Zahl*vekt2;
template<class T>
mathVektor<T> operator*(T number, const mathVektor<T> &v)
{   mathVektor<T> temp = v;
    return temp*=number;            // Aufruf von operator*=()
}

// binrer * Operator fr den Fall vekt1 = vekt2 * Zahl;
template<class T>
mathVektor<T> operator*(const mathVektor<T> &v, T number)
{   mathVektor<T> temp = v;
    return temp*=number;            // Aufruf von operator*=()
}

!!! Ende Listing 8

!!! Listing 9

template<class T>
class Matrix : public Vektor<mathVektor<T> >
{ protected:
    int yDim;
  public:
    Matrix(int=0, int=0);
    int Zeilen()  const { return xDim;}
    int Spalten() const { return yDim;}

    // mathematische Operatoren und Funktionen
    Matrix<T>& I();                   // Einheitsmatrix erzeugen
    Matrix<T>& operator*=(T);         // Multiplikationsoperator
    // ... weitere Operatoren und Funktionen
};

// Implementierung:

template<class T>
Matrix<T>::Matrix(int x, int y)
: Vektor<mathVektor<T> >(x), yDim(y)
{   mathVektor<T> temp(y);
    for (int i=0; i<x; i++) start[i] = temp;
}

!!! Ende Listing 9

!!! Listing 10

template<class T>                         // Multiplikationsoperator
Matrix<T>& Matrix<T>::operator*=(T faktor)
{   for (int i=0; i < xDim; i++)
         start[i] *= faktor;         //   mathVektor<T>::operator*=()
    return *this;
}

template<class T>                         // Einheitsmatrix
Matrix<T>& Matrix<T>::I()
{   for (int i=0;i<xDim; i++)
      for (int j=0;j<yDim ;j++)
          start[i][j] = (i==j) ? T(1) : T(0);
    return *this;
}

!!! Ende Listing 10

!!! Listing 11

template<class T>
class Matrix3D : public Vektor<Matrix<T> >
{ protected:
    int yDim, zDim;
  public:
    Matrix3D(int=0, int=0, int=0);
    int xDIM() const { return xDim;}
    int yDIM() const { return yDim;}
    int zDIM() const { return zDim;}
    Matrix3D<T>& I();                     // Einheitsmatrix
    Matrix3D<T>& operator*=(T);           // Multiplikationsoperator
    // weitere Operatoren u. Funktionen ...
};


// Implementierung:

template<class T>
Matrix3D<T>::Matrix3D(int x, int y, int z)
: Vektor<Matrix<T> >(x), yDim(y), zDim(z)
{   Matrix<T> temp(y,z);
    for (int i=0; i<x; i++) start[i] = temp;
}

!!! Ende Listing 11

!!! Listing 12

template<class T>                         // Einheitsmatrix
Matrix3D<T>& Matrix3D<T>::I() {
   for (int i = 0 ; i< xDim; i++)
      for (int j = 0 ; j < yDim ;j++)
         for (int k = 0 ; k < zDim ;k++)
            start[i][j][k] = (i==j &&j==k) ? T(1) : T(0);
   return *this;
}

template<class T>                       // Multiplikationsoperator
Matrix3D<T>& Matrix3D<T>::operator*=(T faktor)
{   for (int i=0; i < xDim; i++)
        start[i] *= faktor;             //   Matrix<T>::operator*=()
    return *this;
}

!!! Ende Listing 12

!!! Listing 13

Matrix3D<double> M3(3,15,2);
   for (int i = 0 ; i< M3.xDIM(); i++)
      for (int j = 0 ; j < M3.yDIM() ;j++)
         for (int k = 0 ; k < M3.zDIM() ;k++)
         {    M3[i][j][k] = was_auch_immer();
              cout << M3[i][j][k];
         }

M3 *= 12.7823738;
// .... usw.

!!! Ende Listing 13

